// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Components/StaticMeshComponent.h"
#include "EngineUtils.h"

#include "MyParticle.generated.h"

UCLASS()
class LENNARDJONESPLUGIN_API AMyParticle : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AMyParticle();

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Lennard - Jones parameters")
		float eps = 17.7f;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Lennard - Jones parameters")
		float sig = 41.f;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Lennard - Jones parameters")
		float U;

	UPROPERTY(VisibleAnywhere, BlueprintReadWrite, Category = "Lennard - Jones parameters")
		float CurrentTime = 0.0f;

	UPROPERTY(VisibleAnywhere, BlueprintReadWrite, Category = "Lennard - Jones parameters")
		float force = 0.0f;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Lennard - Jones parameters")
		UMaterial* Mat;

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

	float ComputeForce(float r);

	UStaticMeshComponent* MeshComponent;
	UMaterialInstanceDynamic* Material;

public:
	// Called every frame
	virtual void Tick(float DeltaTime) override;
};
